<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/postcard-1.0.1/src/accumulator.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>accumulator.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../postcard/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
</pre><pre class="rust"><code><span class="doccomment">//! An accumulator used to collect chunked COBS data and deserialize it.</span>

<span class="kw">use</span> <span class="ident">serde::Deserialize</span>;

<span class="doccomment">/// An accumulator used to collect chunked COBS data and deserialize it.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is often useful when you receive &quot;parts&quot; of the message at a time, for example when draining</span>
<span class="doccomment">/// a serial port buffer that may not contain an entire uninterrupted message.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Examples</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Deserialize a struct by reading chunks from a [`Read`]er.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```rust</span>
<span class="doccomment">/// use postcard::accumulator::{CobsAccumulator, FeedResult};</span>
<span class="doccomment">/// use serde::Deserialize;</span>
<span class="doccomment">/// use std::io::Read;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # let mut input_buf = [0u8; 256];</span>
<span class="doccomment">/// # #[derive(serde::Serialize, Deserialize, Debug, PartialEq, Eq)]</span>
<span class="doccomment">/// # struct MyData {</span>
<span class="doccomment">/// #     a: u32,</span>
<span class="doccomment">/// #     b: bool,</span>
<span class="doccomment">/// #     c: [u8; 16],</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// let input = /* Anything that implements the `Read` trait */</span>
<span class="doccomment">/// # postcard::to_slice_cobs(&amp;MyData {</span>
<span class="doccomment">/// #     a: 0xabcdef00,</span>
<span class="doccomment">/// #     b: true,</span>
<span class="doccomment">/// #     c: [0xab; 16],</span>
<span class="doccomment">/// # }, &amp;mut input_buf).unwrap();</span>
<span class="doccomment">/// # let mut input = &amp;input[..];</span>
<span class="doccomment">///</span>
<span class="doccomment">/// let mut raw_buf = [0u8; 32];</span>
<span class="doccomment">/// let mut cobs_buf: CobsAccumulator&lt;256&gt; = CobsAccumulator::new();</span>
<span class="doccomment">///</span>
<span class="doccomment">/// while let Ok(ct) = input.read(&amp;mut raw_buf) {</span>
<span class="doccomment">///     // Finished reading input</span>
<span class="doccomment">///     if ct == 0 {</span>
<span class="doccomment">///         break;</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///</span>
<span class="doccomment">///     let buf = &amp;raw_buf[..ct];</span>
<span class="doccomment">///     let mut window = &amp;buf[..];</span>
<span class="doccomment">///</span>
<span class="doccomment">///     &#39;cobs: while !window.is_empty() {</span>
<span class="doccomment">///         window = match cobs_buf.feed::&lt;MyData&gt;(&amp;window) {</span>
<span class="doccomment">///             FeedResult::Consumed =&gt; break &#39;cobs,</span>
<span class="doccomment">///             FeedResult::OverFull(new_wind) =&gt; new_wind,</span>
<span class="doccomment">///             FeedResult::DeserError(new_wind) =&gt; new_wind,</span>
<span class="doccomment">///             FeedResult::Success { data, remaining } =&gt; {</span>
<span class="doccomment">///                 // Do something with `data: MyData` here.</span>
<span class="doccomment">///</span>
<span class="doccomment">///                 dbg!(data);</span>
<span class="doccomment">///</span>
<span class="doccomment">///                 remaining</span>
<span class="doccomment">///             }</span>
<span class="doccomment">///         };</span>
<span class="doccomment">///     }</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Read`]: std::io::Read</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-defmt&quot;</span>, <span class="ident">derive</span>(<span class="ident">defmt::Format</span>))]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CobsAccumulator</span><span class="op">&lt;</span><span class="kw">const</span> <span class="ident">N</span>: <span class="ident">usize</span><span class="op">&gt;</span> {
    <span class="ident">buf</span>: [<span class="ident">u8</span>; <span class="ident">N</span>],
    <span class="ident">idx</span>: <span class="ident">usize</span>,
}

<span class="doccomment">/// The result of feeding the accumulator.</span>
<span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use-defmt&quot;</span>, <span class="ident">derive</span>(<span class="ident">defmt::Format</span>))]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">FeedResult</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Consumed all data, still pending.</span>
    <span class="ident">Consumed</span>,

    <span class="doccomment">/// Buffer was filled. Contains remaining section of input, if any.</span>
    <span class="ident">OverFull</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>]),

    <span class="doccomment">/// Reached end of chunk, but deserialization failed. Contains remaining section of input, if.</span>
    <span class="doccomment">/// any</span>
    <span class="ident">DeserError</span>(<span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>]),

    <span class="doccomment">/// Deserialization complete. Contains deserialized data and remaining section of input, if any.</span>
    <span class="ident">Success</span> {
        <span class="doccomment">/// Deserialize data.</span>
        <span class="ident">data</span>: <span class="ident">T</span>,

        <span class="doccomment">/// Remaining data left in the buffer after deserializing.</span>
        <span class="ident">remaining</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>],
    },
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="kw">const</span> <span class="ident">N</span>: <span class="ident">usize</span><span class="op">&gt;</span> <span class="ident">CobsAccumulator</span><span class="op">&lt;</span><span class="ident">N</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Create a new accumulator.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="self">Self</span> {
        <span class="ident">CobsAccumulator</span> {
            <span class="ident">buf</span>: [<span class="number">0</span>; <span class="ident">N</span>],
            <span class="ident">idx</span>: <span class="number">0</span>,
        }
    }

    <span class="doccomment">/// Appends data to the internal buffer and attempts to deserialize the accumulated data into</span>
    <span class="doccomment">/// `T`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">feed</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">input</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> [<span class="ident">u8</span>]) -&gt; <span class="ident">FeedResult</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="ident">T</span><span class="op">&gt;</span>
    <span class="kw">where</span>
        <span class="ident">T</span>: <span class="kw">for</span><span class="op">&lt;</span><span class="lifetime">&#39;de</span><span class="op">&gt;</span> <span class="ident">Deserialize</span><span class="op">&lt;</span><span class="lifetime">&#39;de</span><span class="op">&gt;</span>,
    {
        <span class="kw">if</span> <span class="ident">input</span>.<span class="ident">is_empty</span>() {
            <span class="kw">return</span> <span class="ident">FeedResult::Consumed</span>;
        }

        <span class="kw">let</span> <span class="ident">zero_pos</span> <span class="op">=</span> <span class="ident">input</span>.<span class="ident">iter</span>().<span class="ident">position</span>(<span class="op">|</span><span class="kw-2">&amp;</span><span class="ident">i</span><span class="op">|</span> <span class="ident">i</span> <span class="op">==</span> <span class="number">0</span>);

        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">n</span>) <span class="op">=</span> <span class="ident">zero_pos</span> {
            <span class="comment">// Yes! We have an end of message here.</span>
            <span class="comment">// Add one to include the zero in the &quot;take&quot; portion</span>
            <span class="comment">// of the buffer, rather than in &quot;release&quot;.</span>
            <span class="kw">let</span> (<span class="ident">take</span>, <span class="ident">release</span>) <span class="op">=</span> <span class="ident">input</span>.<span class="ident">split_at</span>(<span class="ident">n</span> <span class="op">+</span> <span class="number">1</span>);

            <span class="comment">// Does it fit?</span>
            <span class="kw">if</span> (<span class="self">self</span>.<span class="ident">idx</span> <span class="op">+</span> <span class="ident">n</span>) <span class="op">&lt;</span><span class="op">=</span> <span class="ident">N</span> {
                <span class="comment">// Aw yiss - add to array</span>
                <span class="self">self</span>.<span class="ident">extend_unchecked</span>(<span class="ident">take</span>);

                <span class="kw">let</span> <span class="ident">retval</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident"><span class="kw">crate</span>::from_bytes_cobs</span>::<span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">buf</span>[..<span class="self">self</span>.<span class="ident">idx</span>]) {
                    <span class="prelude-val">Ok</span>(<span class="ident">t</span>) =&gt; <span class="ident">FeedResult::Success</span> {
                        <span class="ident">data</span>: <span class="ident">t</span>,
                        <span class="ident">remaining</span>: <span class="ident">release</span>,
                    },
                    <span class="prelude-val">Err</span>(<span class="kw">_</span>) =&gt; <span class="ident">FeedResult::DeserError</span>(<span class="ident">release</span>),
                };
                <span class="self">self</span>.<span class="ident">idx</span> <span class="op">=</span> <span class="number">0</span>;
                <span class="ident">retval</span>
            } <span class="kw">else</span> {
                <span class="self">self</span>.<span class="ident">idx</span> <span class="op">=</span> <span class="number">0</span>;
                <span class="ident">FeedResult::OverFull</span>(<span class="ident">release</span>)
            }
        } <span class="kw">else</span> {
            <span class="comment">// Does it fit?</span>
            <span class="kw">if</span> (<span class="self">self</span>.<span class="ident">idx</span> <span class="op">+</span> <span class="ident">input</span>.<span class="ident">len</span>()) <span class="op">&gt;</span> <span class="ident">N</span> {
                <span class="comment">// nope</span>
                <span class="kw">let</span> <span class="ident">new_start</span> <span class="op">=</span> <span class="ident">N</span> <span class="op">-</span> <span class="self">self</span>.<span class="ident">idx</span>;
                <span class="self">self</span>.<span class="ident">idx</span> <span class="op">=</span> <span class="number">0</span>;
                <span class="ident">FeedResult::OverFull</span>(<span class="kw-2">&amp;</span><span class="ident">input</span>[<span class="ident">new_start</span>..])
            } <span class="kw">else</span> {
                <span class="comment">// yup!</span>
                <span class="self">self</span>.<span class="ident">extend_unchecked</span>(<span class="ident">input</span>);
                <span class="ident">FeedResult::Consumed</span>
            }
        }
    }

    <span class="doccomment">/// Extend the internal buffer with the given input.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Panics</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Will panic if the input does not fit in the internal buffer.</span>
    <span class="kw">fn</span> <span class="ident">extend_unchecked</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">input</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) {
        <span class="kw">let</span> <span class="ident">new_end</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">idx</span> <span class="op">+</span> <span class="ident">input</span>.<span class="ident">len</span>();
        <span class="self">self</span>.<span class="ident">buf</span>[<span class="self">self</span>.<span class="ident">idx</span>..<span class="ident">new_end</span>].<span class="ident">copy_from_slice</span>(<span class="ident">input</span>);
        <span class="self">self</span>.<span class="ident">idx</span> <span class="op">=</span> <span class="ident">new_end</span>;
    }
}

<span class="attribute">#[<span class="ident">test</span>]</span>
<span class="kw">fn</span> <span class="ident">loop_test</span>() {
    <span class="attribute">#[<span class="ident">derive</span>(<span class="ident">serde::Serialize</span>, <span class="ident">Deserialize</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
    <span class="kw">struct</span> <span class="ident">Demo</span> {
        <span class="ident">a</span>: <span class="ident">u32</span>,
        <span class="ident">b</span>: <span class="ident">u8</span>,
    }

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">raw_buf</span> <span class="op">=</span> [<span class="number">0u8</span>; <span class="number">64</span>];
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cobs_buf</span>: <span class="ident">CobsAccumulator</span><span class="op">&lt;</span><span class="number">64</span><span class="op">&gt;</span> <span class="op">=</span> <span class="ident">CobsAccumulator::new</span>();

    <span class="kw">let</span> <span class="ident">ser</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::to_slice_cobs</span>(<span class="kw-2">&amp;</span><span class="ident">Demo</span> { <span class="ident">a</span>: <span class="number">10</span>, <span class="ident">b</span>: <span class="number">20</span> }, <span class="kw-2">&amp;mut</span> <span class="ident">raw_buf</span>).<span class="ident">unwrap</span>();

    <span class="kw">if</span> <span class="kw">let</span> <span class="ident">FeedResult::Success</span> { <span class="ident">data</span>, <span class="ident">remaining</span> } <span class="op">=</span> <span class="ident">cobs_buf</span>.<span class="ident">feed</span>(<span class="ident">ser</span>) {
        <span class="macro">assert_eq!</span>(<span class="ident">Demo</span> { <span class="ident">a</span>: <span class="number">10</span>, <span class="ident">b</span>: <span class="number">20</span> }, <span class="ident">data</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">remaining</span>.<span class="ident">len</span>(), <span class="number">0</span>);
    } <span class="kw">else</span> {
        <span class="macro">panic!</span>()
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>